--- ChangeLog	2005/05/26 15:19:21	1.2
+++ ChangeLog	2005/05/26 22:01:34
@@ -1,3 +1,8 @@
+2005-05-26  Joerg Hoehle <hoehle@users.sourceforge.net>
+
+	* swank.lisp (present-symbol-before-p): make it conform to its
+	specification -- sort first by package and then by symbol name.
+
 2005-05-21  Joerg Hoehle <hoehle@users.sourceforge.net>
 
 	* swank-cmucl.lisp, swank-sbcl.lisp, swank-clisp.lisp
--- swank.lisp	2005/04/27 19:16:21	1.1
+++ swank.lisp	2005/05/26 22:00:13
@@ -2825,19 +2825,28 @@
     (let ((y (funcall f x)))
       (and y (list y)))))
 
-(defun present-symbol-before-p (a b)
+(defun present-symbol-before-p (x y)
   "Return true if A belongs before B in a printed summary of symbols.
 Sorted alphabetically by package name and then symbol name, except
 that symbols accessible in the current package go first."
+  (declare (type symbol x y))
   (flet ((accessible (s)
-           (find-symbol (symbol-name s) *buffer-package*)))
-    (cond ((and (accessible a) (accessible b))
-           (string< (symbol-name a) (symbol-name b)))
-          ((accessible a) t)
-          ((accessible b) nil)
-          (t
-           (string< (package-name (symbol-package a))
-                    (package-name (symbol-package b)))))))
+	   (or
+	    (eq (symbol-package s) *buffer-package*) ; a short-cut
+            ;; Test breaks on NIL for package that does not inherit it
+	    (eq (find-symbol (symbol-name s) *buffer-package*) s))))
+    (let ((ax (accessible x)) (ay (accessible y)))
+    (if ax
+	(if ay
+	    (string< (symbol-name x) (symbol-name y))
+	    t)
+	(if ay
+	    nil
+	    (let ((px (symbol-package x))
+		  (py (symbol-package y)))
+	      (if (eq px py)
+		  (string< (symbol-name x) (symbol-name y))
+		  (string< px py))))))))
 
 (let ((regex-hash (make-hash-table :test #'equal)))
   (defun compiled-regex (regex-string)
